%Convergence rate of the exptrapolated Euler method
function extraExplEulKonv

% AWP: y' = y, y(0) = 1;
% convergence stody for the extrapolated Euler method
f=@(y) -y;
y0=1;

% end point
T = 1;

%sequence of number of macro steps (we're conducting a convergence study)
N=2.^(2:5);

%sequence of number of micro steps
n=1:6;

%compute the absolute error for each number of macro steps
err=zeros(size(N));
for i=1:length(N)
    err(i)=abs(exp(-T)-extraExplEul(f,y0,T,N(i),n));
end

%loglog-plot
figure
loglog(N,err);


p=polyfit(log(N),log(err),1);
fprintf('Convergence rate = %3.4f\n',p(1));